#include "komponentpart.h"
#include "komponentwidget.h"

#include <kinstance.h>
#include <klocale.h>
#include <kaboutdata.h>
#include <qwidget.h>

extern "C"
{
	void *init_libpyrokomponent()
	{
		return new KomponentFactory();
	}
};

KInstance *KomponentFactory::s_instance = 0L;

KomponentFactory::KomponentFactory()
{
}

KomponentFactory::~KomponentFactory()
{
	if (s_instance)
	{
		delete s_instance->aboutData();
		delete s_instance;
	}
	s_instance = 0L;
}

QObject *KomponentFactory::createObject(QObject *parent, const char *name, const char*, const QStringList& )
{
	QObject *obj = new KomponentPart((QWidget*)parent, name);
	emit objectCreated(obj);
	return obj;
}

KInstance *KomponentFactory::instance()
{
	if (!s_instance) s_instance = new KInstance( aboutData() );
	return s_instance;
}

KAboutData *KomponentFactory::aboutData()
{
	KAboutData *about = new KAboutData("pyrokomponent", I18N_NOOP("Pyrokomponent"), "0.1");
	return about;
}

KomponentPart::KomponentPart(QWidget *parent, const char *name)
: KParts::ReadOnlyPart(parent, name)
{
	setInstance(KomponentFactory::instance());

	m_widget = new KomponentWidget(true, parent);
	m_widget->setFocusPolicy(QWidget::ClickFocus);
	setWidget(m_widget);

	m_extension = new KomponentBrowserExtension(this);
}

KomponentPart::~KomponentPart()
{
	closeURL();
}

bool KomponentPart::openFile()
{
	m_widget->open(m_file);
	return true;
}

KomponentBrowserExtension::KomponentBrowserExtension(KomponentPart *parent)
: KParts::BrowserExtension(parent, "KomponentBrowserExtension")
{
}

KomponentBrowserExtension::~KomponentBrowserExtension()
{
}
