#ifndef KOMPONENT_PART_H
#define KOMPONENT_PART_H

#include <kparts/browserextension.h>
#include <klibloader.h>

class KAboutData;
class KInstance;
class KomponentBrowserExtension;
class KomponentWidget;

class KomponentFactory : public KLibFactory
{
	Q_OBJECT
	public:
		KomponentFactory();
		virtual ~KomponentFactory();

		virtual QObject* createObject(QObject* parent = 0, const char* name = 0,
			const char* classname = "QObject", const QStringList &args = QStringList());
		static KInstance *instance();
		static KAboutData *aboutData();

	private:
		static KInstance *s_instance;
};

class KomponentPart: public KParts::ReadOnlyPart
{
	Q_OBJECT
	public:
		KomponentPart(QWidget *parent, const char *name);
		virtual ~KomponentPart();

	protected:
		virtual bool openFile();

	private:
		KomponentBrowserExtension *m_extension;
		KomponentWidget *m_widget;
};

class KomponentBrowserExtension : public KParts::BrowserExtension
{
	Q_OBJECT
	friend class KomponentPart;
	public:
		KomponentBrowserExtension(KomponentPart *parent);
		virtual ~KomponentBrowserExtension();
};

#endif
