#ifndef KOMPONENT_WIDGET_H
#define KOMPONENT_WIDGET_H

#include <qwidget.h>
#include <qevent.h>

#define EMBEDDED 1

#ifdef EMBEDDED
#include <Python.h>
#endif

class KomponentWidget : public QWidget
{
	Q_OBJECT
	public:
		KomponentWidget(bool embedded, QWidget *parent = NULL, const char *name = NULL);
		~KomponentWidget();

		void open(QString file);
		void execute(QString method, QStringList args);

	public slots:
		void slotStarted();
		void launchProgram();

	protected:
		void keyPressEvent(QKeyEvent *e);
		void mouseMoveEvent(QMouseEvent *e);
		void mousePressEvent(QMouseEvent *e);
		void paintEvent(QPaintEvent *e);

	private:
		QString m_file;
#ifdef EMBEDDED
		PyObject *pxDict;
#endif
};

#endif

